import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        long[] d = new long[n];
        int f = nextInt();
        if (f == 1) {
            for (int i = 0; i < n; i++) {
                d[i] = nextLong();
            }
        } else {
            int m = nextInt();
            long x = nextLong();
            long y = nextLong();
            long z = nextLong();
            for (int i = 0; i < m; i++) {
                d[i] = nextLong();
            }
            for (int i = m; i < n; i++) {
                d[i] = ((x * d[i - 2] + y * d[i - 1] + z) % 1000000000) + 1;
            }
        }
        long[] pref_max = new long[n];
        pref_max[0] = d[0];
        for (int i = 1; i < n; i++) {
            pref_max[i] = Math.max(pref_max[i - 1], Math.max(0,d[i]-i));
        }
        long[] suf_max = new long[n];
        suf_max[n-1] = d[n-1]-n+1;
        for (int i = n-2; i >=0; i--) {
            suf_max[i] = Math.max(suf_max[i + 1], Math.max(0,d[i]-i));
        }
        long mina = 10000000000L;
        int idx_ans = -1;
        for (int i = 0; i < n; i++) {
            long a = 0;
            if(i==0)a=suf_max[0];
            else if(i==n-1)a=Math.max(pref_max[n-2]+1,d[n-1]-(n-1));
            else a=Math.max(Math.max(0,pref_max[i-1]-n+i),Math.max(d[i],suf_max[i+1]+i));
            if (a < mina) {
                mina = a;
                idx_ans = i + 1;
            }
        }
        out.println(mina + " " + idx_ans);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}