import java.io.*;
import java.util.*;

public class Main {
    static int n, k;
    static int[] p, w;
    static int ans1 = 0, ans2 = 0;

    static void rec(int now, String s) {
        if (now == n-1) {
            int[] g = new int[n];
            int sum = 0;
            int cnt = 0;
            for (int i = 0; i < s.length(); ++i) {
                if (s.charAt(i) == '1') {
                    g[i]++;
                    g[p[i]]++;
                    sum += w[i];
                    cnt++;
                }
            }
            boolean e = true;
            for (int i = 0; i < n; ++i) {
                if (g[i] > k) {
                    e = false;
                    break;
                }
            }
            if (e) {
                if (cnt > ans1) {
                    ans1 = cnt;
                    ans2 = sum;
                } else if (cnt == ans1) ans2 = Math.min(ans2, sum);
            }
            return;
        }
        if (now != 0) {
            rec(now + 1, s + "1");
        }
        rec(now + 1, s + "0");

    }

    public static void main(String[] args) throws IOException {
        n = nextInt();
        k = nextInt();
        p = new int[n - 1];
        w = new int[n - 1];
        for (int i = 0; i < n - 1; ++i) {
            p[i] = nextInt();
            w[i] = nextInt();
            p[i]--;
        }
        rec(0, "");
        out.println(ans1 + " " + ans2);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}