import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        long[] d = new long[n];
        int f = nextInt();
        if (f == 1) {
            for (int i = 0; i < n; i++) {
                d[i] = nextLong();
            }
        } else {
            int m = nextInt();
            long x = nextLong();
            long y = nextLong();
            long z = nextLong();
            for (int i = 0; i < m; i++) {
                d[i] = nextLong();
            }
            for (int i = m; i < n; i++) {
                d[i] = ((x * d[i - 2] + y * d[i - 1] + z) % 1000000000) + 1;
            }
        }
        long l = 0;
        long r = (long) 1e10;
        int ans = -1;
        while (l + 1 < r) {
            long mid = (l + r) / 2;
            int idx_ans = -1;
            for (int i = 0; i < n; i++) {
                long a = mid;
                int idx = i;
                boolean ch = true;
                for (int j = 0; j < n; j++) {
                    if (d[idx] > a) {
                        ch = false;
                        break;
                    }
                    idx = (idx + 1) % n;
                    a++;
                }
                if (ch) {
                    idx_ans = i + 1;
                    break;
                }
            }
            if (idx_ans!=-1){ r = mid;ans=idx_ans;}
            else l = mid;
        }
        out.println(r+" "+ans);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}