import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        long[] d = new long[n];
        int f = nextInt();
        if (f == 1) {
            for (int i = 0; i < n; i++) {
                d[i] = nextLong();
            }
        } else {
            int m = nextInt();
            long x = nextLong();
            long y = nextLong();
            long z = nextLong();
            for (int i = 0; i < m; i++) {
                d[i] = nextLong();
            }
            for (int i = m; i < n; i++) {
                d[i] = ((x * d[i - 2] + y * d[i - 1] + z) % 1000000000) + 1;
            }
        }
        long mina = 10000000000L;
        int idx_ans = -1;
        for (int i = 0; i < 1; i++) {
            long a=0;
            int idx=i;
            for (int j = 0; j < n; j++) {
                a= Math.max(a,Math.max(0,d[idx]-j));
                idx=(idx+1)%n;
            }
            if(a<mina){
                mina=a;
                idx_ans=i+1;
            }
        }
        out.println(mina+" "+idx_ans);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}