import java.io.*;
import java.util.*;

public class Main {
    static class Ayo {
        long a;
        long b;
        long c;

        Ayo(long a, long b, long c) {
            this.a = a;
            this.b = b;
            this.c = c;
        }
    }

    static class cmp implements Comparator<Ayo> {
        public int compare(Ayo o1, Ayo o2) {
            if (o1.a == o2.a) {
                if (o1.b == o2.b) {
                    return Long.compare(o1.c, o2.c);
                } else return Long.compare(o1.b, o2.b);
            }
            return Long.compare(o1.a, o2.a);
        }
    }

    public static void main(String[] args) throws IOException {
        int t = nextInt();
        int n = nextInt();
        Ayo[] a = new Ayo[n];
        TreeMap<Ayo, Integer> m = new TreeMap<>(new cmp());
        for (int i = 0; i < n; i++) {
            long x1 = nextLong();
            long y1 = nextLong();
            long x2 = nextLong();
            long y2 = nextLong();
            long x3 = nextLong();
            long y3 = nextLong();
            a[i] = new Ayo((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2), (x3 - x2) * (x3 - x2) + (y3 - y2) * (y3 - y2), (x1 - x3) * (x1 - x3) + (y1 - y3) * (y1 - y3));
            m.put(a[i], m.getOrDefault(a[i], 0) + 1);
        }
        long ans=0;
        for(Ayo i:m.keySet()){
            if(m.get(i)>=4){
                ans+= (long) m.get(i) *(m.get(i)-1)*(m.get(i)-2)*(m.get(i)-3)/24;
            }
        }
        out.println(ans);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}