import java.io.*;
import java.util.*;

public class Main {
    static long gcd(long a, long b) {
        while (b != 0) {
            long buf = a;
            a = b;
            b = buf % b;
        }
        return a;
    }

    static class Ayo {
        long p, q;

        Ayo(long p, long q) {
            this.p = p;
            this.q = q;
        }
    }

    static class cmp implements Comparator<Ayo> {
        public int compare(Ayo o1, Ayo o2) {
            long h1 = o1.p * o2.q;
            long h2 = o2.p * o1.q;
            return Long.compare(h1, h2);
        }
    }

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int t = nextInt();
        long[] a = new long[n];
        long[] b = new long[n];
        for (int i = 0; i < n; ++i) {
            a[i] = nextLong();
        }
        for (int i = 0; i < n; i++) {
            b[i] = nextLong();
        }
        Ayo[] ch = new Ayo[n * n];
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                long g = gcd(a[i], b[j]);
                ch[i * n + j] = new Ayo(a[i] / g, b[j] / g);
            }
        }
        Arrays.sort(ch,new cmp());
        while(t--!=0){
            int idx=nextInt()-1;
            out.println(ch[idx].p+" "+ch[idx].q);
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}